#!/bin/bash

# Built with MooseX::App::Plugin::BashCompletion::Command on 2024/05/02

kanku_COMMANDS='help api ca check_configs console db destroy init ip list login logout lsi pfwd rabbit rcomment retrigger rguest rhistory rjob rr rtrigger rworker setup snapshot ssh startui startvm status stopui stopvm up urlwrapper'

_kanku_macc_help() {
    if [ $COMP_CWORD = 2 ]; then
        _kanku_compreply "$kanku_COMMANDS"
    else
        COMPREPLY=()
    fi
}

_kanku_macc_api() {
    _kanku_compreply "--as_admin --aa --apiurl -a --user -u --rc_file --keyring -k --password -p --list -l --details -d --data --help -h --usage -?"
}

_kanku_macc_ca() {
    _kanku_compreply "--create -c --force -f --ca_path -p --help -h --usage -?"
}

_kanku_macc_check_configs() {
    _kanku_compreply "--jobs -j --server -s --devel -d --help -h --usage -?"
}

_kanku_macc_console() {
    _kanku_compreply "--log_file --domain_name -d --file --log_stdout --help -h --usage -?"
}

_kanku_macc_db() {
    _kanku_compreply "--server --devel -d --dsn --upgrade -u --install -i --status -s --dbfile --homedir --share_dir --dbuser -U --dbpass -P --help -h --usage -?"
}

_kanku_macc_destroy() {
    _kanku_compreply "--log_file --domain_name -d --file --log_stdout --keep_volumes --help -h --usage -?"
}

_kanku_macc_init() {
    _kanku_compreply "--default_job -j --domain_name -d --memory -m --vcpu -c --project --prj --package --pkg --repository --repo --force -f --output -o -F --pool --apiurl -a --help -h --usage -?"
}

_kanku_macc_ip() {
    _kanku_compreply "--log_file --domain_name -d --file --log_stdout --login_user -u --login_pass -p --help -h --usage -?"
}

_kanku_macc_list() {
    _kanku_compreply "--global -g --help -h --usage -?"
}

_kanku_macc_login() {
    _kanku_compreply "--as_admin --aa --apiurl -a --user -u --rc_file --keyring -k --password -p --help -h --usage -?"
}

_kanku_macc_logout() {
    _kanku_compreply "--as_admin --aa --apiurl -a --user -u --rc_file --keyring -k --password -p --help -h --usage -?"
}

_kanku_macc_lsi() {
    _kanku_compreply "--name -n --apiurl -a --project -p --help -h --usage -?"
}

_kanku_macc_pfwd() {
    _kanku_compreply "--domain_name -d --ports -p --interface -i --help -h --usage -?"
}

_kanku_macc_rabbit() {
    _kanku_compreply "--listen -l --send -s --props -p --config -c --notification -n --output_plugin -o --help -h --usage -?"
}

_kanku_macc_rcomment() {
    _kanku_compreply "--as_admin --aa --apiurl -a --user -u --rc_file --keyring -k --password -p --list -l --details -d --job_id -j --comment_id -C --message -m --create -c --show -s --modify -M --delete -D --help -h --usage -?"
}

_kanku_macc_retrigger() {
    _kanku_compreply "--as_admin --aa --apiurl -a --user -u --rc_file --keyring -k --password -p --list -l --details -d --job -j --help -h --usage -?"
}

_kanku_macc_rguest() {
    _kanku_compreply "--as_admin --aa --apiurl -a --user -u --rc_file --keyring -k --password -p --list -l --details -d --host --domain --help -h --usage -?"
}

_kanku_macc_rhistory() {
    _kanku_compreply "--as_admin --aa --apiurl -a --user -u --rc_file --keyring -k --password -p --list -l --details -d --full --limit --page --state --latest --job_name --worker --help -h --usage -?"
}

_kanku_macc_rjob() {
    _kanku_compreply "--as_admin --aa --apiurl -a --user -u --rc_file --keyring -k --password -p --list -l --details -d --config -c --filter -f --help -h --usage -?"
}

_kanku_macc_rr() {
    _kanku_compreply "--as_admin --aa --apiurl -a --user -u --rc_file --keyring -k --password -p --help -h --usage -?"
}

_kanku_macc_rtrigger() {
    _kanku_compreply "--as_admin --aa --apiurl -a --user -u --rc_file --keyring -k --password -p --list -l --details -d --job -j --job_group -J --config -c --help -h --usage -?"
}

_kanku_macc_rworker() {
    _kanku_compreply "--as_admin --aa --apiurl -a --user -u --rc_file --keyring -k --password -p --details -d --list -l --help -h --usage -?"
}

_kanku_macc_setup() {
    _kanku_compreply "--server --distributed --devel --worker --user --images_dir --apiurl --osc_user --osc_pass --dsn --ssl --apache --mq_host --mq_vhost --mq_user --mq_pass --interactive -i --dns_domain_name --ovs_ip_prefix --master --help -h --usage -?"
}

_kanku_macc_snapshot() {
    _kanku_compreply "--log_file --domain_name -d --file --log_stdout --create -c --revert -R --remove -r --list -l --name -n --help -h --usage -?"
}

_kanku_macc_ssh() {
    _kanku_compreply "--log_file --domain_name -d --file --log_stdout --user -u --ipaddress -i --execute -e --agent_forward -A --x11_forward -X --help -h --usage -?"
}

_kanku_macc_startui() {
    _kanku_compreply "--help -h --usage -?"
}

_kanku_macc_startvm() {
    _kanku_compreply "--log_file --domain_name -d --file --log_stdout --help -h --usage -?"
}

_kanku_macc_status() {
    _kanku_compreply "--log_file --domain_name -d --file --log_stdout --help -h --usage -?"
}

_kanku_macc_stopui() {
    _kanku_compreply "--help -h --usage -?"
}

_kanku_macc_stopvm() {
    _kanku_compreply "--log_file --domain_name -d --file --log_stdout --force -f --help -h --usage -?"
}

_kanku_macc_up() {
    _kanku_compreply "--log_file --domain_name -d --file --log_stdout --offline -o --job_name -j --pool -p --skip_all_checks --skip_check_project --skip_check_package --skip_check_domain -S --help -h --usage -?"
}

_kanku_macc_urlwrapper() {
    _kanku_compreply "--url -u --outdir -d --help -h --usage -?"
}

_kanku_compreply() {
    COMPREPLY=($(compgen -W "$1" -- ${COMP_WORDS[COMP_CWORD]}))
}

_kanku_macc() {
    case $COMP_CWORD in
        0)
            ;;
        1)
            _kanku_compreply "$kanku_COMMANDS"
            ;;
        *)
            eval _kanku_macc_${COMP_WORDS[1]}

    esac
}

complete -o default -F _kanku_macc kanku


